// (C) Copyright 2008 Donald A. Graft, All Rights Reserved
//
// CUVIDServer is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//  
// CUVIDServer is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//  
// You should have received a copy of the GNU General Public License
// along with GNU Make; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 

// Set NVGLOBAL in one and only one of your source files
// that includes this header file.
#ifdef NVGLOBAL
#define NVXTN
#else
#define NVXTN extern
#endif

#define MAX_WIDTH 2048
#define MAX_HEIGHT 1088
#define MAX_RPC_MESSAGE 10*1024*1024

// RPC method op codes.
#define OP_FLUSH 0
#define OP_SET_MODE 1
#define OP_DECODE_NALU 2

// Defines for OP_SET_MODE
#define WEAVE 0
#define DEINTERLACE 1
#define BOB 2

// Shared memory for communications between the server and the client.
struct TSharedMemory
{
	DWORD client_process_id;
	unsigned char rpc_message[MAX_RPC_MESSAGE];
	int rpc_result;
	unsigned int width;
	unsigned int height;
	unsigned int pitch;
	unsigned int progressive;
	unsigned char nv12_frame[(3*MAX_WIDTH*MAX_HEIGHT)/2];
};
NVXTN TSharedMemory *pMsg;
NVXTN HANDLE hMap; // "NVSharedMem"

// Events for coordinating the server and the client.
NVXTN HANDLE hExec; // "NVExec"
NVXTN HANDLE hDone; // "NVDone"
NVXTN HANDLE hStopDecoding; // "NVStopDecoding"
NVXTN HANDLE hFrameRequested; // "NVRequested"
NVXTN HANDLE hFrameAvailable; // "NVAvailable"

NVXTN bool use_D3D;